%bcond_without mead
%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif

%define section free
%define reltag .redhat_1
%define namedversion %{version}-redhat-1

%define maven_version 2.6.0-redhat-1

Name:           apache-cxf-xjc-utils
Version:        2.6.0
Release:        1%{reltag}%{?dist}
Summary:        Apache CXF XJC Utils

Group:          Development/Libraries

%if %with mead
Source100: org.apache.cxf.xjc-utils-xjc-utils-2.6.0-redhat-1-sources.zip
Source101: org.apache.cxf.xjc-utils-xjc-utils-2.6.0-redhat-1-patches.zip
Source102: cxf-xjc-ts-2.6.0-redhat-1.pom
Source103: cxf-xjc-ts-2.6.0-redhat-1-javadoc.jar
Source104: cxf-xjc-ts-2.6.0-redhat-1-sources.jar
Source105: cxf-xjc-ts-2.6.0-redhat-1.jar
Source106: cxf-xjc-boolean-2.6.0-redhat-1.jar
Source107: cxf-xjc-boolean-2.6.0-redhat-1.pom
Source108: cxf-xjc-boolean-2.6.0-redhat-1-javadoc.jar
Source109: cxf-xjc-boolean-2.6.0-redhat-1-sources.jar
Source110: cxf-xjc-dv-2.6.0-redhat-1-javadoc.jar
Source111: cxf-xjc-dv-2.6.0-redhat-1.pom
Source112: cxf-xjc-dv-2.6.0-redhat-1.jar
Source113: cxf-xjc-dv-2.6.0-redhat-1-sources.jar
Source114: cxf-xjc-pl-2.6.0-redhat-1.jar
Source115: cxf-xjc-pl-2.6.0-redhat-1.pom
Source116: cxf-xjc-pl-2.6.0-redhat-1-sources.jar
Source117: cxf-xjc-pl-2.6.0-redhat-1-javadoc.jar
Source118: xjc-utils-2.6.0-redhat-1.pom
Source119: cxf-xjc-wsdlextension-2.6.0-redhat-1.jar
Source120: cxf-xjc-wsdlextension-2.6.0-redhat-1-sources.jar
Source121: cxf-xjc-wsdlextension-2.6.0-redhat-1-javadoc.jar
Source122: cxf-xjc-wsdlextension-2.6.0-redhat-1.pom
%endif

License:        ASF 2.0
URL:            http://cxf.apache.org
%if %without mead
# svn export http://svn.apache.org/repos/asf/cxf/xjc-utils/tags/xjc-utils-2.4.0/
# tar -jcf apache-cxf-xjc-utils-2.4.0.tar.bz2 xjc-utils-2.4.0
Source0:        apache-cxf-xjc-utils-2.4.0.tar.bz2
Source1:        apache-cxf-xjc-utils-jpp-depmap.xml
Patch0:         apache-cxf-xjc-utils-vman-pom.patch
%endif

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch

%if %without mead
BuildRequires:  jpackage-utils 
BuildRequires:  maven2
BuildRequires:  maven-plugin-plugin
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-resources-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-release-plugin
BuildRequires:  maven-checkstyle-plugin
BuildRequires:  maven-pmd-plugin
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-site-plugin
BuildRequires:  maven-shared
BuildRequires:  maven-shared-downloader
BuildRequires:  jboss-parent
BuildRequires:  jvnet-parent
BuildRequires:  oss-parent
%endif

Requires: jpackage-utils
Requires(post): jpackage-utils 
Requires(postun): jpackage-utils 

%if %without mead
BuildRequires:  glassfish-jaxb
BuildRequires:  jboss-jaxb-api_2.2_spec
BuildRequires:  jakarta-commons-lang
BuildRequires:  jboss-specs-parent
BuildRequires:  wsdl4j
BuildRequires:  relaxngDatatype
BuildRequires:  xml-commons-resolver
# glassfish-jaxb needs
BuildRequires:  codemodel
BuildRequires:  istack-commons
BuildRequires:  xsom
BuildRequires:  dtd-parser
BuildRequires:  txw2 
BuildRequires:  txwc2 
BuildRequires:  rngom
%endif

Requires:  glassfish-jaxb
Requires:  jakarta-commons-lang
Requires:  jboss-jaxb-api_2.2_spec
Requires:  jboss-specs-parent
Requires:  wsdl4j
Requires:  relaxngDatatype
Requires:  xml-commons-resolver

%description
Apache CXF XJC Utils

%package -n cxf-xjc-dv
Summary:        Apache CXF XJC Default Value Plugin
Group:          Development/Java

Requires:       apache-cxf-xjc-utils

%description -n cxf-xjc-dv
%{summary}.

%package -n cxf-xjc-ts
Summary:        Apache CXF XJC toString Plugin
Group:          Development/Java

Requires:       apache-cxf-xjc-utils

%description -n cxf-xjc-ts
%{summary}.

%package -n cxf-xjc-boolean
Summary:        Apache CXF XJC Boolean Getter Plugin
Group:          Development/Java

Requires:       apache-cxf-xjc-utils

%description -n cxf-xjc-boolean
%{summary}.

%if %without mead
%package -n cxf-xjc-plugin
Summary:        Apache CXF XSD2Java Plugin
Group:          Development/Java

Requires:       apache-cxf-xjc-utils

%description -n cxf-xjc-plugin
%{summary}.
%endif

%package -n cxf-xjc-wsdlextension
Summary:        Apache CXF XJC WSDL Extension Plugin
Group:          Development/Java

Requires:       apache-cxf-xjc-utils

%description -n cxf-xjc-wsdlextension
%{summary}.

%package -n cxf-xjc-pl
Summary:        Apache CXF XJC Property Listener Plugin
Group:          Development/Java

Requires:       apache-cxf-xjc-utils

%description -n cxf-xjc-pl
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Group:          Documentation

Summary:        Javadoc for %{name}
Requires:       jpackage-utils

%description javadoc
API documentation for %{name}.


%prep
%if %without mead
%setup -q -n xjc-utils-2.4.0
%patch0 -p1
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mvn-jpp \
        -e \
        -Dmaven2.jpp.mode=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.skip=true \
        -DaltDeploymentRepository=jboss-releases::default::file:maven2-brew \
        deploy javadoc:aggregate
%endif

%install
rm -rf %{buildroot}

# jars
install -d -m 0755 %{buildroot}%{_javadir}
%if %without mead
install -m 644 dv/target/cxf-xjc-dv-%{namedversion}.jar   %{buildroot}%{_javadir}/cxf-xjc-dv-%{namedversion}.jar
install -m 644 ts/target/cxf-xjc-ts-%{namedversion}.jar   %{buildroot}%{_javadir}/cxf-xjc-ts-%{namedversion}.jar
install -m 644 boolean/target/cxf-xjc-boolean-%{namedversion}.jar   %{buildroot}%{_javadir}/cxf-xjc-boolean-%{namedversion}.jar
install -m 644 cxf-xjc-plugin/target/cxf-xjc-plugin-%{namedversion}.jar   %{buildroot}%{_javadir}/cxf-xjc-plugin-%{namedversion}.jar
install -m 644 wsdlextension/target/cxf-xjc-wsdlextension-%{namedversion}.jar   %{buildroot}%{_javadir}/cxf-xjc-wsdlextension-%{namedversion}.jar
install -m 644 property-listener/target/cxf-xjc-pl-%{namedversion}.jar   %{buildroot}%{_javadir}}/cxf-xjc-pl-%{namedversion}.jar
%else
%{__cp} -p %{_sourcedir}/cxf-xjc-dv-%{namedversion}-sources.jar %{buildroot}%{_javadir}                                                  
%{__cp} -p %{_sourcedir}/cxf-xjc-dv-%{namedversion}.jar %{buildroot}%{_javadir}                                                                   
%{__cp} -p %{_sourcedir}/cxf-xjc-ts-%{namedversion}-sources.jar %{buildroot}%{_javadir}                                                  
%{__cp} -p %{_sourcedir}/cxf-xjc-ts-%{namedversion}.jar %{buildroot}%{_javadir} 
%{__cp} -p %{_sourcedir}/cxf-xjc-boolean-%{namedversion}-sources.jar %{buildroot}%{_javadir}                                                  
%{__cp} -p %{_sourcedir}/cxf-xjc-boolean-%{namedversion}.jar %{buildroot}%{_javadir} 
%{__cp} -p %{_sourcedir}/cxf-xjc-wsdlextension-%{namedversion}-sources.jar %{buildroot}%{_javadir}                                                  
%{__cp} -p %{_sourcedir}/cxf-xjc-wsdlextension-%{namedversion}.jar %{buildroot}%{_javadir} 
%{__cp} -p %{_sourcedir}/cxf-xjc-pl-%{namedversion}-sources.jar %{buildroot}%{_javadir}                                                  
%{__cp} -p %{_sourcedir}/cxf-xjc-pl-%{namedversion}.jar %{buildroot}%{_javadir} 
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; \
    do ln -sf ${jar} `echo $jar| sed "s|-%{namedversion}||g"`; done)

%add_to_maven_depmap org.apache.cxf.xjc-utils xjc-utils %{namedversion} JPP xjc-utils
%add_to_maven_depmap org.apache.cxf.xjcplugins cxf-xjc-dv %{namedversion} JPP cxf-xjc-dv
%add_to_maven_depmap org.apache.cxf.xjcplugins cxf-xjc-ts %{namedversion} JPP cxf-xjc-ts
%add_to_maven_depmap org.apache.cxf.xjcplugins cxf-xjc-boolean %{namedversion} JPP cxf-xjc-boolean
%add_to_maven_depmap org.apache.cxf cxf-xjc-plugin %{namedversion} JPP cxf-xjc-plugin
%add_to_maven_depmap org.apache.cxf.xjcplugins cxf-xjc-wsdlextension %{namedversion} JPP cxf-xjc-wsdlextension
%add_to_maven_depmap org.apache.cxf.xjcplugins cxf-xjc-pl %{namedversion} JPP cxf-xjc-pl

# poms
install -d -m 755 %{buildroot}%{_mavenpomdir}
%if %without mead
install -pm 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-xjc-utils.pom
install -pm 644 dv/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-cxf-xjc-dv.pom
install -pm 644 ts/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-cxf-xjc-ts.pom
install -pm 644 boolean/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-cxf-xjc-boolean.pom
install -pm 644 cxf-xjc-plugin/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-cxf-xjc-plugin.pom
install -pm 644 wsdlextension/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-cxf-xjc-wsdlextension.pom
install -pm 644 property-listener/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-cxf-xjc-pl.pom
%else
%{__cp} -p %{_sourcedir}/xjc-utils-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-xjc-utils.pom
%{__cp} -p %{_sourcedir}/cxf-xjc-dv-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-cxf-xjc-dv.pom
%{__cp} -p %{_sourcedir}/cxf-xjc-ts-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-cxf-xjc-ts.pom
%{__cp} -p %{_sourcedir}/cxf-xjc-boolean-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-cxf-xjc-boolean.pom
%{__cp} -p %{_sourcedir}/cxf-xjc-wsdlextension-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-cxf-xjc-wsdlextension.pom
%{__cp} -p %{_sourcedir}/cxf-xjc-pl-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-cxf-xjc-pl.pom

%endif

# javadoc
install -d -m 0755 %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%if %without mead
cp -pr target/site/api*/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/
rm -rf target/site/api*
%else
%{__unzip} -qq %{_sourcedir}/cxf-xjc-dv-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/cxf-xjc-dv
%{__unzip} -qq %{_sourcedir}/cxf-xjc-ts-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/cxf-xjc-ts
%{__unzip} -qq %{_sourcedir}/cxf-xjc-boolean-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/cxf-xjc-boolean
%{__unzip} -qq %{_sourcedir}/cxf-xjc-wsdlextension-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/cxf-xjc-wsdlextension
%{__unzip} -qq %{_sourcedir}/cxf-xjc-pl-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/cxf-xjc-pl
%{__rm} -r %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/cxf-xjc-dv/META-INF
%{__rm} -r %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/cxf-xjc-ts/META-INF
%{__rm} -r %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/cxf-xjc-boolean/META-INF
%{__rm} -r %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/cxf-xjc-wsdlextension/META-INF
%{__rm} -r %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/cxf-xjc-pl/META-INF
%endif
ln -s %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%post
%update_maven_depmap

%postun
%update_maven_depmap

%clean
rm -rf %{buildroot}

%files
%defattr(0644,root,root,0755) 
%{_datadir}/maven2/poms/JPP-xjc-utils.pom
%{_mavendepmapfragdir}/%{name}

%files -n cxf-xjc-dv
%defattr(0644,root,root,0755) 
%{_javadir}*/cxf-xjc-dv-%{namedversion}.jar
%{_javadir}*/cxf-xjc-dv.jar
%{_javadir}*/cxf-xjc-dv-%{namedversion}-sources.jar
%{_javadir}*/cxf-xjc-dv-sources.jar
%{_datadir}/maven2/poms/JPP-cxf-xjc-dv.pom

%files -n cxf-xjc-ts
%defattr(0644,root,root,0755) 
%{_javadir}*/cxf-xjc-ts-%{namedversion}.jar
%{_javadir}*/cxf-xjc-ts.jar
%{_javadir}*/cxf-xjc-ts-%{namedversion}-sources.jar
%{_javadir}*/cxf-xjc-ts-sources.jar
%{_datadir}/maven2/poms/JPP-cxf-xjc-ts.pom

%files -n cxf-xjc-boolean
%defattr(0644,root,root,0755) 
%{_javadir}*/cxf-xjc-boolean-%{namedversion}.jar
%{_javadir}*/cxf-xjc-boolean.jar
%{_javadir}*/cxf-xjc-boolean-%{namedversion}-sources.jar
%{_javadir}*/cxf-xjc-boolean-sources.jar
%{_datadir}/maven2/poms/JPP-cxf-xjc-boolean.pom

%if %without mead
%files -n cxf-xjc-plugin
%defattr(0644,root,root,0755) 
%{_javadir}*/cxf-xjc-plugin-%{namedversion}.jar
%{_javadir}*/cxf-xjc-plugin.jar
%{_datadir}/maven2/poms/JPP-cxf-xjc-plugin.pom
%endif

%files -n cxf-xjc-wsdlextension
%defattr(0644,root,root,0755) 
%{_javadir}*/cxf-xjc-wsdlextension-%{namedversion}.jar
%{_javadir}*/cxf-xjc-wsdlextension.jar
%{_javadir}*/cxf-xjc-wsdlextension-%{namedversion}-sources.jar
%{_javadir}*/cxf-xjc-wsdlextension-sources.jar
%{_datadir}/maven2/poms/JPP-cxf-xjc-wsdlextension.pom

%files -n cxf-xjc-pl
%defattr(0644,root,root,0755) 
%{_javadir}*/cxf-xjc-pl-%{namedversion}.jar
%{_javadir}*/cxf-xjc-pl.jar
%{_javadir}*/cxf-xjc-pl-%{namedversion}-sources.jar
%{_javadir}*/cxf-xjc-pl-sources.jar
%{_datadir}/maven2/poms/JPP-cxf-xjc-pl.pom

%files javadoc
%defattr(0644,root,root,0755) 
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri Feb 22 2013 Yong Yang <yyang@redhat.com> - 2.6.0-1.redhat_1
- 2.6.0

* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 2.4.0-11.redhat_2.4
- Rebuild for MD5

* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 2.4.0-10.redhat_2.4
- Rebuild unsigned

* Mon Aug 13 2012 Fernando Nasser <fnasser@redhat.com> - 2.4.0-10.redhat_2.3
- Rebuild unsigned

* Fri Aug 10 2012 Fernando Nasser <fnasser@redhat.com> - 2.4.0-10.redhat_2.2
- Rebuild unsigned

* Tue Jul 31 2012 Fernando Nasser <fnasser@redhat.com> - 2.4.0-10.redhat_1.1
- Fix release tag

* Wed Jul 25 2012 Fernando Nasser <fnasser@redhat.com> - 2.4.0-10_redhat_1.1
- Rebuild unsigned

* Wed Jul 25 2012 Hui Wang <huwang@redhat.com> - 2.4.0-10_redhat_1
- First mead build 
- Fix direcotry of jar installation

* Fri May 04 2012 Hui Wang <huwang@redhat.com> - 2.4.0-9_redhat_1
- Update pom patch to remove repositories
- BR codemodel, istack-commons, xsom, dtd-parser, txw2, txwc2 and rngom which glassfish-jaxb depdends on

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 2.4.0-8_redhat_1.3.1
- Rebuild using cache signing

* Mon Mar 25 2012 Yong Yang <yyang@redhat.com> - 0:2.4.0-8_redhat_1.2
- Update vman patch, set the wsdlextension dep's version, xjc-plugin cannot resolve extension's dep's version by BOMs
- Add BR jvnet-parent

* Wed Feb 08 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.4.0-8_redhat_1.2
- Use new resolver package

* Fri Jan 27 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.4.0-8_redhat_1.1
- Do not reqire maven2 at run-time

* Wed Dec 21 2011 Yong Yang <yyang@redhat.com> - 0:2.4.0-8_redhat_1
- Add Requires for sub-packages
- Add dependencies and B(R)s for xml-commons-resolver12, relaxngDatatype, these are needed for runtime

* Tue Dec 20 2011 Yong Yang <yyang@redhat.com> - 0:2.4.0-7_redhat_1
- Update vman patch
- Add jpp-depmap for jtidy

* Thu Dec 01 2011 Yong Yang <yyang@redhat.com> - 0:2.4.0-6_redhat_1
- Add cxf-xjc-pl

* Wed Nov 30 2011 Yong Yang <yyang@redhat.com> - 0:2.4.0-5_redhat_1
- Fix cxf-xjc-plugin groupId

* Wed Nov 30 2011 Hui Wang <huwang@redhat.com> - 0:2.4.0-4_redhat_1
- Fix repolib

* Tue Nov 29 2011 Hui Wang <huwang@redhat.com> - 0:2.4.0-3_redhat_1
- Rebuild

* Tue Nov 29 2011 Hui Wang <huwang@redhat.com> - 0:2.4.0-2_redhat_1
- Add cxf-xjc-plugin and cxf-xjc-wsdlextension artifacts

* Tue Oct 25 2011 Hui Wang <huwang@redhat.com> - 0:2.4.0-1_redhat_1
- Upgrade tp 2.4.0

* Wed Sep 21 2011 Hui Wang <huwang@redhat.com> - 0:2.3.2-3
- Build for wolf

* Thu Jul 28 2011 Hui Wang <huwang@redhat.com> - 0:2.3.2-2
- Add workaround for deploy-file bug that causes wrong directory of cxf-xjc-boolean.pom and cxf-xjc-bug671.pom

* Thu Jul 28 2011 Hui Wang <huwang@redhat.com> - 0:2.3.2-1
- Upgrade to 2.3.2

* Thu Jul 28 2011 Hui Wang <huwang@redhat.com> - 0:2.3.0-3
- Rebuild

* Thu Jul 21 2011 Hui Wang <huwang@redhat.com> - 0:2.3.0-2
- Rebuild

* Tue Jul 19 2011 Hui Wang <huwang@redhat.com> - 0:2.3.0-1
- First release
